freeslot("SPR_MESG", "S_MESG_NORMAL", "S_MESG_HEAL", "S_MESG_SENTRY", "S_MESG_DISPENS", "S_MESG_TELEPT", "S_MESG_LOW", "S_MESG_EXCLAM", "S_MESG_GOODJOB", "S_MESG_HELP", "sfx_medic")

states[S_MESG_NORMAL] = {SPR_MESG, A|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_MESG_HELP] = {SPR_MESG, I|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_MESG_GOODJOB] = {SPR_MESG, H|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_MESG_LOW] = {SPR_MESG, F|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_MESG_HEAL] = {SPR_MESG, B|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_MESG_SENTRY] = {SPR_MESG, C|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_MESG_DISPENS] = {SPR_MESG, D|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_MESG_TELEPT] = {SPR_MESG, E|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_MESG_EXCLAM] = {SPR_MESG, G|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}

freeslot("SPR_SRMG", "S_SRM_SPIKES", "S_SRM_ROLL", "S_SRM_METAL", "S_SRM_READY")

states[S_SRM_READY] = {SPR_SRMG, D|FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}
states[S_SRM_SPIKES] = {SPR_SRMG, A|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_SRM_ROLL] = {SPR_SRMG, C|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}
states[S_SRM_METAL] = {SPR_SRMG, B|FF_FULLBRIGHT, 2*TICRATE, nil, 0, 0, S_NULL}

local IconTypes = {
	[0] = S_MESG_NORMAL,
	[1] = S_MESG_HEAL,
	[2] = S_MESG_SENTRY,
	[3] = S_MESG_DISPENS,
	[4] = S_MESG_TELEPT,
	[5] = S_MESG_NORMAL,
	[6] = S_MESG_EXCLAM,
	[7] = S_MESG_GOODJOB,
	[8] = S_MESG_HELP,
	
	[9] = S_SRM_SPIKES,
	[10] = S_SRM_ROLL,
	[11] = S_SRM_METAL
}

rawset(_G, "TF2_Message", function(mo, mesgtype, seen)
	local message = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY)
	message.target = mo
	if mesgtype
		if mesgtype == 1
			message.medic = true
			if mo.player
				if mo.player.rings
					message.state = S_MESG_NORMAL
				else
					message.state = S_MESG_LOW
				end	
			else
				message.state = S_MESG_NORMAL
			end
		else
			message.state = S_MESG_NORMAL
		end	
	else
		message.medic = true
		if mo.player
			if mo.player.rings
				message.state = S_MESG_NORMAL
			else
				message.state = S_MESG_LOW
			end	
		else
			message.state = S_MESG_NORMAL
		end
	end	
	message.spriteyoffset =	mobjinfo[mo.type].height + 15*FRACUNIT
	message.tics = 2*TICRATE
	message.awshitimdissapearing = 2*TICRATE
	local icon = P_SpawnMobjFromMobj(message, 0, 0, 0, MT_OVERLAY)
	icon.target = message
	if not seen
		icon.spriteyoffset = message.spriteyoffset
		icon.color = mo.color
		if mesgtype
			icon.state = IconTypes[mesgtype]
			if mesgtype == 11
				icon.spriteyscale = FRACUNIT/4
				icon.spritexscale = FRACUNIT/4
				icon.spriteyoffset = (message.spriteyoffset + 225*FRACUNIT)
			end
		else
			icon.state = S_MESG_NORMAL
		end
	else
		icon.skin = seen.mo.skin
		icon.color = seen.mo.color
		icon.state = S_MESG_NORMAL
		icon.sprite = SPR_PLAY
		icon.sprite2 = SPR2_LIFE
		icon.spriteyoffset = message.spriteyoffset + 13*FRACUNIT
	end	
	icon.medicicon = true
end)

local byebye = {
	[0] = FF_FULLBRIGHT,
	[1] = FF_TRANS90,
	[2] = FF_TRANS80,
	[3] = FF_TRANS70,
	[4] = FF_TRANS60,
	[5] = FF_TRANS50,
	[6] = FF_TRANS40,
	[7] = FF_TRANS30,
	[8] = FF_TRANS20,
	[9] = FF_TRANS10
}

addHook("PlayerMsg", function(player, msgtype, target, msg)
	if player.valid and not player.spectator and player.mo and player.mo.valid
		if not msgtype
			for play in players.iterate()
				if play.valid and play.mo and play.mo.valid and play.mo.skin and not play.spectator
					if string.find(string.lower(msg), string.lower(tostring(play.name)))
						TF2_Message(player.mo, 5, play)
					end
				end	
			end
			if not novoicespam
				if (string.find(string.lower(msg), "medic") or string.find(string.lower(msg), "medick"))
				or (string.find(string.lower(msg), "need")
				and (string.find(string.lower(msg), "medical") or string.find(string.lower(msg), "medickal"))
				and string.find(string.lower(msg), "attention"))
					TF2_Message(player.mo, 1)
					if TF2_MedicVC[player.mo.skin]
						S_StartSound(player.mo, TF2_MedicVC[player.mo.skin][P_RandomRange(1, #TF2_MedicVC[player.mo.skin])])
					else
						S_StartSound(player.mo, sfx_medic)
					end	
				end
				if (string.find(string.lower(msg), "good") or string.find(string.lower(msg), "gud")
				or string.find(string.lower(msg), "gub") or string.find(string.lower(msg), "best")
				or string.find(string.lower(msg), "better") or string.find(string.lower(msg), "great")
				or string.find(string.lower(msg), "amazing") or string.find(string.lower(msg), "nice")
				or string.find(string.lower(msg), "outstanding"))
				and string.find(string.lower(msg), "job")
					TF2_Message(player.mo, 7)
					if TF2_GoodJobVC[player.mo.skin]
						S_StartSound(player.mo, TF2_GoodJobVC[player.mo.skin][P_RandomRange(1, #TF2_GoodJobVC[player.mo.skin])])
					end	
				end
				if string.find(string.lower(msg), "go")
				and not string.find(string.lower(msg), "good")
					TF2_Message(player.mo, 6)
					if TF2_GoGoGoVC[player.mo.skin]
						S_StartSound(player.mo, TF2_GoGoGoVC[player.mo.skin][P_RandomRange(1, #TF2_GoGoGoVC[player.mo.skin])])
					end	
				end
				if string.find(string.lower(msg), "help")
					TF2_Message(player.mo, 8)
					if TF2_HelpVC[player.mo.skin]
						S_StartSound(player.mo, TF2_HelpVC[player.mo.skin][P_RandomRange(1, #TF2_HelpVC[player.mo.skin])])
					end	
				end
				if not (string.find(string.lower(msg), "here")
				or string.find(string.lower(msg), "there")
				or string.find(string.lower(msg), "'ere")) then return end
				if string.find(string.lower(msg), "sentry")
					TF2_Message(player.mo, 2)
					S_StartSound(player.mo, TF2_BuildVC[player.mo.skin][3])
				elseif string.find(string.lower(msg), "dispenser")
					TF2_Message(player.mo, 3)
					S_StartSound(player.mo, TF2_BuildVC[player.mo.skin][2])
				elseif (string.find(string.lower(msg), "teleporter")
				or string.find(string.lower(msg), "tele")
				or string.find(string.lower(msg), "tp"))
					TF2_Message(player.mo, 4)
					S_StartSound(player.mo, TF2_BuildVC[player.mo.skin][1])
				end
			else
				if ((string.find(string.lower(msg), "medic") or string.find(string.lower(msg), "medick"))
				or (string.find(string.lower(msg), "need")
				and (string.find(string.lower(msg), "medical") or string.find(string.lower(msg), "medickal"))
				and string.find(string.lower(msg), "attention")))
				or ((string.find(string.lower(msg), "good") or string.find(string.lower(msg), "gud")
				or string.find(string.lower(msg), "gub") or string.find(string.lower(msg), "best")
				or string.find(string.lower(msg), "better") or string.find(string.lower(msg), "great")
				or string.find(string.lower(msg), "amazing") or string.find(string.lower(msg), "nice")
				or string.find(string.lower(msg), "outstanding"))
				and string.find(string.lower(msg), "job"))
				or (string.find(string.lower(msg), "go")
				and not string.find(string.lower(msg), "good"))
				or ((string.find(string.lower(msg), "help"))
				or (string.find(string.lower(msg), "here")
				or string.find(string.lower(msg), "there")
				or string.find(string.lower(msg), "'ere"))
				and string.find(string.lower(msg), "sentry")
				or string.find(string.lower(msg), "dispenser")
				or (string.find(string.lower(msg), "teleporter")
				or string.find(string.lower(msg), "tele")
				or string.find(string.lower(msg), "tp")))
					CONS_Printf(player, 'Voice spam is turned off! Use command "voicemenu" instead!')
				end	
			end	
		end
	end	
end)

addHook("ThinkFrame", do
	for mo in mobjs.iterate()
		if mo and mo.valid
			if mo.medicicon
			and mo.target
				mo.frame = (states[mo.state].frame & ~FF_FULLBRIGHT)|(mo.target.frame & ~FF_FRAMEMASK)
				mo.tics = mo.target.tics
			end
			if mo.awshitimdissapearing
				mo.awshitimdissapearing = $ - 1
				if mo.awshitimdissapearing <= 9
					local bop = byebye[mo.awshitimdissapearing]
					if mo.medic
						if mo.target.player
							if mo.target.player.rings
								mo.frame = A|FF_FULLBRIGHT|bop
							else
								mo.frame = F|FF_FULLBRIGHT|bop
							end	
						else
							mo.frame = A|FF_FULLBRIGHT|bop
						end
					else
						mo.frame = A|FF_FULLBRIGHT|bop
					end
				end
			end
		end
	end
end)

local winner = {
	[9] = 10,
	[10] = 11,
	[11] = 9
}

freeslot("MT_WINAURA", "S_WINAURA")

mobjinfo[MT_WINAURA] = {
	doomednum = -1,
	spawnstate = S_NULL,
	spawnhealth = 1,
	speed = FRACUNIT*60,
	radius = 10*FRACUNIT,
	height = 10*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

states[S_WINAURA] = {SPR_NULL, A|FF_FULLBRIGHT, 2, nil, 1, 0, S_NULL}

local function TF2_WinAura(player, colorr)
	local aura = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_OVERLAY)
	aura.target = player.mo
	aura.tracer = player.mo
	aura.state = S_WINAURA
	aura.skin = player.mo.skin
	aura.color = colorr
	aura.sprite = player.mo.sprite
	aura.sprite2 = player.mo.sprite2
	aura.spriteyscale = FRACUNIT + FRACUNIT/13 + FixedMul(cos((leveltime%360)*ANG1*5), FRACUNIT/15)
	aura.spritexscale = FRACUNIT + FRACUNIT/13 + FixedMul(cos((leveltime%360)*ANG1*5), FRACUNIT/15)
	aura.fuse = 2
	aura.colorized = true
	aura.aura = true
	return aura
end

addHook("MobjThinker", function(mo)
	if mo and mo.aura
		if mo.fuse
			local bop = byebye[mo.fuse%9]
			mo.frame = $|bop|FF_FULLBRIGHT
		end
		if mo.target
			mo.skin = mo.target.skin
			mo.sprite = mo.target.sprite
			mo.sprite2 = mo.target.sprite2
			mo.frame = mo.target.frame & ~FF_TRANSMASK
			mo.blendmode = AST_ADD
		end
	end
end)

rawset(_G, "msswinner", 0)

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
	and not player.spectator
		/*if multiplayer
			if server == player
				local aura = TF2_WinAura(player, SKINCOLOR_PURPLE)
				aura.spriteyscale = FRACUNIT + FRACUNIT/8 + FixedMul(cos((leveltime%360)*ANG1*5), FRACUNIT/10)
				aura.spritexscale = FRACUNIT + FRACUNIT/8 + FixedMul(cos((leveltime%360)*ANG1*5 + ANGLE_90), FRACUNIT/10)
				local aura2 = TF2_WinAura(player, SKINCOLOR_YELLOW)
				aura2.spriteyscale = FRACUNIT + FRACUNIT/12 - FixedMul(cos((leveltime%360)*ANG1*5), FRACUNIT/15)
				aura2.spritexscale = FRACUNIT + FRACUNIT/12 - FixedMul(cos((leveltime%360)*ANG1*5 + ANGLE_90), FRACUNIT/15)
				local aura3 = TF2_WinAura(player, player.mo.color)
				aura3.spriteyscale = FRACUNIT + FRACUNIT/5 - FixedMul(cos((leveltime%360)*ANG1*5 + ANGLE_90), FRACUNIT/8)
				aura3.spritexscale = FRACUNIT + FRACUNIT/5 - FixedMul(cos((leveltime%360)*ANG1*5 - ANGLE_90), FRACUNIT/8)
			end
		end*/
		if player.presstf
			player.presstf = $ - 1
		end
		if msswinner == player
			TF2_WinAura(player, player.mo.color)
		end
			if player.letsgo
				player.letsgo = $ - 1
				player.pflags = $|PF_STASIS
				if player.battle
					player.batlin = true
					local opp = player.battle
					local ran1 = P_RandomRange(9, 11)
					local ran2 = P_RandomRange(9, 11)
					if player.letsgo == 2*TICRATE + (TICRATE/2)
						P_FlashPal(player, PAL_WHITE, 2)
						P_FlashPal(opp.player, PAL_WHITE, 2)
						local aura1 = TF2_WinAura(player, player.mo.color)
						aura1.spriteyscale = FRACUNIT + FRACUNIT/5
						aura1.spritexscale = FRACUNIT + FRACUNIT/5
						aura1.fuse = 15
						local aura2 = TF2_WinAura(opp.player, opp.color)
						aura2.spriteyscale = FRACUNIT + FRACUNIT/5
						aura2.spritexscale = FRACUNIT + FRACUNIT/5
						aura2.fuse = 15
					end
					if player.letsgo == 2*TICRATE
						P_FlashPal(player, PAL_WHITE, 2)
						P_FlashPal(opp.player, PAL_WHITE, 2)
						local aura1 = TF2_WinAura(player, player.mo.color)
						aura1.spriteyscale = FRACUNIT + FRACUNIT/5
						aura1.spritexscale = FRACUNIT + FRACUNIT/5
						aura1.fuse = 15
						local aura2 = TF2_WinAura(opp.player, opp.color)
						aura2.spriteyscale = FRACUNIT + FRACUNIT/5
						aura2.spritexscale = FRACUNIT + FRACUNIT/5
						aura2.fuse = 15
					end
					if player.letsgo == 2*TICRATE - (TICRATE/2)
						P_FlashPal(player, PAL_WHITE, 2)
						P_FlashPal(opp.player, PAL_WHITE, 2)
						local aura1 = TF2_WinAura(player, player.mo.color)
						aura1.spriteyscale = FRACUNIT + FRACUNIT/5
						aura1.spritexscale = FRACUNIT + FRACUNIT/5
						aura1.fuse = 15
						local aura2 = TF2_WinAura(opp.player, opp.color)
						aura2.spriteyscale = FRACUNIT + FRACUNIT/5
						aura2.spritexscale = FRACUNIT + FRACUNIT/5
						aura2.fuse = 15
					end
					if player.letsgo == 1*TICRATE
						TF2_Message(player.mo, ran1)
						TF2_Message(opp, ran2)
						if ran2 == winner[ran1]
							msswinner = player
						elseif ran1 == winner[ran2]
							msswinner = opp.player
						else
							local dist = R_PointToDist2(player.mo.x, player.mo.y, opp.x, opp.y)
							local angl = R_PointToAngle2(player.mo.x, player.mo.y, opp.x, opp.y)
							local addx = FixedMul(dist/2, cos(angl))
							local addy = FixedMul(dist/2, sin(angl))
							local tie = P_SpawnMobjFromMobj(player.mo, addx, addy, player.mo.height + 50*FRACUNIT, MT_THOK)
							tie.fuse = TICRATE
							tie.tics = TICRATE
							tie.sprite = SPR_SRMG
							tie.frame = F|FF_FULLBRIGHT
							tie.destscale = FRACUNIT*5
							tie.scalespeed = FRACUNIT/20
						end
					end
				end
			else
				if player.batlin
					player.battle.player.battle = nil
					player.battle.player.spikerollsonic = false
					player.battle = nil
					player.spikerollsonic = false
					player.batlin = false
				end
				if player.cmd.buttons & BT_JUMP
					player.spikerollsonic = false
				end
			end
		if player.spikerollsonic
			player.pflags = $|PF_STASIS
			if not player.batlin
				local ready = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_OVERLAY)
				ready.state = S_SRM_READY
				ready.target = player.mo
				ready.color = player.mo.color
				local rottime = (leveltime%360)*ANG1
				ready.spriteyscale = FRACUNIT/3 + (FixedMul(cos(rottime*5), FRACUNIT/5)/5*2)
				ready.spritexscale = FRACUNIT/3 - (FixedMul(cos(rottime*5 + ANGLE_90), FRACUNIT/5)/5*2)
				ready.spriteyoffset = mobjinfo[player.mo.type].height + 185*FRACUNIT
				for oppon in players.iterate()
					if oppon.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
					and oppon != player
						if P_AproxDistance(P_AproxDistance(oppon.mo.x - player.mo.x, oppon.mo.y - player.mo.y), oppon.mo.z - player.mo.z) <= 150*FRACUNIT
							oppon.presstf = 2
							if oppon.cmd.buttons & BT_TOSSFLAG
								local addx = FixedMul(100*FRACUNIT, cos(player.drawangle))
								local addy = FixedMul(100*FRACUNIT, sin(player.drawangle))
								P_TeleportMove(oppon.mo, player.mo.x+addx, player.mo.y+addy, oppon.mo.z)
								player.mo.momx = 0
								player.mo.momy = 0
								player.mo.momz = 0
								oppon.mo.momx = 0
								oppon.mo.momy = 0
								oppon.mo.momz = 0
								oppon.drawangle = player.drawangle + ANGLE_180
								oppon.mo.angle = player.drawangle + ANGLE_180
								oppon.spikerollsonic = false
								oppon.battle = player.mo
								player.spikerollsonic = false
								player.battle = oppon.mo
								player.letsgo = 3*TICRATE
							end
						end
					end
				end
			end	
		end
	end
end)

local function PressTF(v, player, camera)
	if player.mo and player.valid and player.playerstate == PST_LIVE
		if player.presstf
			v.drawString(160, 190, "Press TOSSFLAG to play Metal-Sonic-Spikes!", V_SNAPTOBOTTOM|V_HUDTRANS|V_ALLOWLOWERCASE|V_YELLOWMAP|V_30TRANS, "thin-center")
		end
	end
end
hud.add(PressTF)